AddStep <- function(inputs, step, ...) {
  # Check inputs
  if (any(c('startR_header', 'startR_workflow') %in% class(inputs))) {
    inputs <- list(inputs)
    names(inputs) <- 'input1'
  }
  if (is.list(inputs)) {
    sapply(inputs, 
      function(x) {
      })
  } else {
    stop("Parameter 'inputs' must be one or a list of objects of the class ",
         "'startR_header' or 'startR_workflow'.")
  }

  # Check step
  if (!('startR_step' %in% class(step))) {
    stop("Parameter 'step' must be a startR step as returned by Step.")
  }

  if (length(inputs) != length(attr(step, 'target_dims'))) {
    stop("The number of provided 'inputs' (", length(inputs), ") does not ",
         "match the number of expected inputs by the provided 'step' (", 
         length(attr(step, 'target_dims')), ").")
  }

  previous_target_dims <- NULL
  for (input in 1:length(inputs)) {
    if (!all(attr(step, 'target_dims')[[input]] %in% attr(inputs[[input]], 'Dimensions'))) {
      stop("The target dimensions required by 'step' for the input ", input, 
           " are not present in the corresponding provided object in 'inputs'.")
    }
    if ('startR_workflow' %in% class(inputs[[input]])) {
      if (is.null(previous_target_dims)) {
        previous_target_dims <- attr(inputs[[input]], 'TargetDims')
      } else {
        dims1 <- rep(1, length(previous_target_dims))
        names(dims1) <- previous_target_dims
        dims2 <- rep(1, length(attr(inputs[[input]], 'TargetDims')))
        names(dims2) <- attr(inputs[[input]], 'TargetDims')
        previous_target_dims <- names(startR:::.MergeArrayDims(dims1, dims2)[[1]])
      }
    }
  }
#  target_dims <- previous_target_dims plus target dims not present in accum_generated_dims (for each output)
#  generated_dims <- all dims present in output not present in target (for each output)
#  removed_dims <- all dims resent in target not present in output (for each output)
#  accm_generated_dims <- accum_generated_dims plus generated_dims minus removed_dims
#  dimensions <- 
#
#  if single output, return single startR_workflow object. otherwise return list of objects
#  result <- list(the names are the names of all outputs of the step,
#                 the values are a
#                 list(inputs = inputs,
#                      step = step,
#                      params = list(...))
#                 attr(___, 'Dimensions') <- 
#                 attr(result, 'TargetDims') <- target_dims
#                 attr(result, 'AccumNewDims') <- accum_new_dims
#                 class(result) <- 'startR_workflow'
#                )
}
