library(startR, lib.loc = '/home/Earth/nmanuben/startR/startR.Rcheck')

shared_dir <- 

debug <- 
start_calls <- 
start_calls_dims <- 
param_dimnames <- 
fun <- 
params <- 
cores_per_job <-

args <- as.integer(commandArgs(TRUE)[-1])

total_specified_dims <- length(args) / 2
chunk_indices <- args[((1:total_specified_dims) - 1) * 2 + 1]
names(chunk_indices) <- param_dimnames
chunks <- as.list(args[((1:total_specified_dims) - 1) * 2 + 2])
names(chunks) <- param_dimnames

data <- vector('list', length(start_calls))
for (input in 1:length(data)) {
  start_call <- start_calls[[input]]
  call_dims <- names(start_calls_dims[[input]])
  dims_to_chunk <- which(call_dims %in% param_dimnames)
  if (length(dims_to_chunk) > 0) {
    for (call_dim in call_dims[dims_to_chunk]) {
      start_call[[call_dim]] <- chunk(chunk_indices[call_dim], chunks[[call_dim]], 
                                      eval(start_call[[call_dim]]))
    }
  }
  data[[input]] <- eval(start_call)
}

Apply <- multiApply::Apply
res <- do.call("Apply",
               c(
                 list(data,
                      inverse_margins = attr(fun, 'target_dims'),
                      AtomicFun = "fun", 
                      parallel = cores_per_job > 1,
                      ncores = cores_per_job),
                 params
                )
              )
rm(data)
gc()

for (component in names(res)) {
  filename <- paste0(component, '__')
  for (i in 1:total_specified_dims) {
    filename <- paste0(filename, param_dimnames[i], '_', chunk_indices[i], '__')
  }
  saveRDS(res[[component]], file = paste0(shared_dir, '/', filename, '.Rds'))
}
rm(res)
gc()
